/*********************************************
 * OPL 12.6.3.0 Model
 * Author: luizcherri
 * Creation Date: 21/10/2016 at 14:12:13
 *********************************************/

using CP;
int input[1..9, 1..9] = [[8,0,0,0,0,0,0,0,0],
                         [0,0,3,6,0,0,0,0,0],
                         [0,7,0,0,9,0,2,0,0],
                         [0,5,0,0,0,7,0,0,0],
                         [0,0,0,0,4,5,7,0,0],
                         [0,0,0,1,0,0,0,3,0],
                         [0,0,1,0,0,0,0,6,8],
                         [0,0,8,5,0,0,0,1,0],
                         [0,9,0,0,0,0,4,0,0]
                         ];

dvar int sudoku[1..9, 1..9] in 1..9 ;
constraints {

	// Fixando os valores de entrada para as variáveis
	forall (i, j in 1..9 : input [i, j] != 0) 
		sudoku[i, j] == input[i, j];

	// Todos os elementos das colunas diferentes
	forall (i in 1..9) 
		allDifferent (all(j in 1..9) sudoku[i,j]);
	
	// Todos os elementos das linhas diferentes
	forall (j in 1..9) 
		allDifferent (all(i in 1..9) sudoku[i,j]);
	
	// Percorrendo sub-blocos
	forall ( block_row , block_column in 0..2)
    	allDifferent (all(l, m in 1..3) sudoku[3 * block_row + l , 3 * block_column + m]);
};

main {
	thisOplModel.generate();
	cp.startNewSearch();
	cp.next();
	for (var i = 1; i<=9 ; i++) {
		for (var j = 1; j<=9; j++){
			if (j%3 == 0 && j!=9){
				write (thisOplModel.sudoku[i][j] + " | ");						
			} else	{	
				write (thisOplModel.sudoku[i][j] + " ");			
 			}			
		} writeln();
		if (i%3==0){
			for (var j = 1; j<=11; j++){
				write ("--");			
			} writeln();
		}
	}		 
}
