// --------------------------------------------------------------------------
// Licensed Materials - Property of IBM
//
// 5725-A06 5725-A29 5724-Y48 5724-Y49 5724-Y54 5724-Y55
// Copyright IBM Corporation 1998, 2013. All Rights Reserved.
//
// Note to U.S. Government Users Restricted Rights:
// Use, duplication or disclosure restricted by GSA ADP Schedule
// Contract with IBM Corp.
// --------------------------------------------------------------------------

/* ------------------------------------------------------------

Problem Description
-------------------

The problem involves choosing colors for the countries on a map in 
such a way that at most four colors (blue, white, yellow, green) are 
used and no neighboring countries are the same color. In this exercise, 
you will find a solution for a map coloring problem with six countries: 
Belgium, Denmark, France, Germany, Luxembourg, and the Netherlands. 

------------------------------------------------------------ */
using CP;

range r = 0..3;

string Names[r] = ["blue", "white", "yellow", "green"]; 
string Pais[1..6] = ["Belgium", "Denmark", "France", "Germany","Luxembourg","Netherlands"]; 



dvar int C[1..6] in r;

minimize max(x in 1..6) C[x];

subject to {  
   C[1] != C[3]; 
   C[1] != C[4]; 
   C[1] != C[6];
 //  C[1] != C[5];
   C[2] != C[4]; 
   C[3] != C[4]; 
   C[3] != C[5]; 
   C[4] != C[5];
   C[4] != C[6];    
}

execute {
   writeln(Pais[1],": ", Names[C[1]]);
   writeln(Pais[2],": ", Names[C[2]]);
   writeln(Pais[3],": ", Names[C[3]]);
   writeln(Pais[4],": ", Names[C[4]]);
   writeln(Pais[5],": ", Names[C[5]]);
   writeln(Pais[6],": ", Names[C[6]]);
}
